Vue UI Components Documentation

Vue ComboBox Component

The ComboBox component for Vue contains an input field with auto-complete functionality and a list of selectable items displayed in a drop-down.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The ComboBox component for Vue requires the following import:

import JqxComboBox from "jqwidgets-scripts/jqwidgets-vue/vue_jqxcombobox.vue";

Add the jqxComboBox component to the components section of the the Vue class:

 components: {
JqxComboBox
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxComboBox/>

<template>
<JqxComboBox :width="300" :height="25"
:source="source" :selectedIndex="0">
</JqxComboBox>
</template>

Properties

The properties of the <JqxComboBox/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
source: [
// Business & Investing
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: Do the Work</div><div>Author: Steven Pressfield</div></div>', label: 'Do the Work', group: 'Business & Investing' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: Think and Grow Rich</div><div>Author: Napoleon Hill</div></div>', label: 'Think and Grow Rich', group: 'Business & Investing' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: The Toyota Way to Continuous...</div><div>Author: Jeffrey K. Liker</div></div>', label: 'The Toyota Way to Continuous...', group: 'Business & Investing' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: Redesigning Leadership </div><div>Author: John Maeda</div></div>', label: 'Redesigning Leadership ', group: 'Business & Investing' },
// Computer & Internet Books
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: MacBook Pro Portable Genius</div><div>Author: Brad Miser</div></div>', label: 'MacBook Pro Portable Genius', group: 'Computer & Internet Books' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: Social Media Metrics Secrets</div><div>Author: John Lovett</div></div>', label: 'Social Media Metrics Secrets', group: 'Computer & Internet Books' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: iPad 2: The Missing Manual</div><div>Author: J D Biersdorfer J.D</div></div>', label: 'iPad 2: The Missing Manual', group: 'Computer & Internet Books' },
// History
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Lincoln and His Admirals</div><div>Author:Craig L. Symonds</div></div>', label: 'Lincoln and His Admirals', group: 'History' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>The Dogs of War: 1861</div><div>Author:Emory M. Thomas</div></div>', label: 'The Dogs of War: 1861', group: 'History' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Cleopatra: A Life</div><div>Author:Stacy Schiff</div></div>', label: 'Cleopatra: A Life', group: 'History' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Mother Teresa: A Biography</div><div>Author:Meg Greene</div></div>', label: 'Mother Teresa: A Biography', group: 'History' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>The Federalist Papers</div><div>Author:John Jay</div></div>', label: 'The Federalist Papers', group: 'History' },
]
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxComboBox @change="onChange()"
:width="300" :height="25"
:source="source" :selectedIndex="0">
</JqxComboBox>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onChange: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxComboBox ref="combobox"></JqxComboBox>

Here how you can use a component's method:

this.$refs.combobox.close();

methods: {
// Add here all used callbacks and/or events
onChange: function () {
// Do something on change
this.$refs.combobox.close();
}
}

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

<template>
<JqxComboBox ref="combobox" @change="onChange()"
:width="300" :height="25"
:source="source" :selectedIndex="0">
</JqxComboBox>
</template>
<script>
// Import the components that will be used
import JqxComboBox from "jqwidgets-scripts/jqwidgets-vue/vue_jqxcombobox.vue";
export default {
components: {
// Adding imported widgets here
JqxComboBox
},
data: function () {
// Define properties which will use in the widget
return {
source: [
// Business & Investing
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: Do the Work</div><div>Author: Steven Pressfield</div></div>', label: 'Do the Work', group: 'Business & Investing' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: Think and Grow Rich</div><div>Author: Napoleon Hill</div></div>', label: 'Think and Grow Rich', group: 'Business & Investing' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: The Toyota Way to Continuous...</div><div>Author: Jeffrey K. Liker</div></div>', label: 'The Toyota Way to Continuous...', group: 'Business & Investing' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: Redesigning Leadership </div><div>Author: John Maeda</div></div>', label: 'Redesigning Leadership ', group: 'Business & Investing' },
// Computer & Internet Books
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: MacBook Pro Portable Genius</div><div>Author: Brad Miser</div></div>', label: 'MacBook Pro Portable Genius', group: 'Computer & Internet Books' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: Social Media Metrics Secrets</div><div>Author: John Lovett</div></div>', label: 'Social Media Metrics Secrets', group: 'Computer & Internet Books' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Title: iPad 2: The Missing Manual</div><div>Author: J D Biersdorfer J.D</div></div>', label: 'iPad 2: The Missing Manual', group: 'Computer & Internet Books' },
// History
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Lincoln and His Admirals</div><div>Author:Craig L. Symonds</div></div>', label: 'Lincoln and His Admirals', group: 'History' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>The Dogs of War: 1861</div><div>Author:Emory M. Thomas</div></div>', label: 'The Dogs of War: 1861', group: 'History' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Cleopatra: A Life</div><div>Author:Stacy Schiff</div></div>', label: 'Cleopatra: A Life', group: 'History' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>Mother Teresa: A Biography</div><div>Author:Meg Greene</div></div>', label: 'Mother Teresa: A Biography', group: 'History' },
{ html: '<div tabIndex=0 style="padding: 1px;"><div>The Federalist Papers</div><div>Author:John Jay</div></div>', label: 'The Federalist Papers', group: 'History' },
]
}
},
beforeCreate: function () {
// Add here any data where you want to transform before components be rendered
},
methods: {
// Add here all used callbacks and/or events
onChange: function () {
// Do something on change
this.$refs.combobox.close();
}
}
}
</script>
<style>
</style>

ComboBox Example

<template>
<div>
<JqxComboBox @select="myComboBoxOnSelect($event)"
:width="150" :height="25" :source="dataAdapter" :selectedIndex="0"
:displayMember="'ContactName'" :valueMember="'CompanyName'">
</JqxComboBox>
<div ref="selectionlog" style="font-size: 12px; font-family: Verdana"></div>
</div>
</template>
<script>
import JqxComboBox from "jqwidgets-scripts/jqwidgets-vue/vue_jqxcombobox.vue";
export default {
components: {
JqxComboBox
},
data: function () {
return {
dataAdapter: new jqx.dataAdapter(this.source)
}
},
beforeCreate: function () {
this.source = {
datatype: 'json',
datafields: [
{ name: 'CompanyName' },
{ name: 'ContactName' }
],
id: 'id',
url: 'sampledata/customers.txt'
};
},
methods: {
myComboBoxOnSelect: function (event) {
if (event.args) {
let item = event.args.item;
if (item) {
let valueElement = document.createElement('div');
valueElement.innerHTML = 'Value: ' + item.value;
let labelElement = document.createElement('div');
labelElement.innerHTML = 'Label: ' + item.label;
let selectionLog = this.$refs.selectionlog;
selectionLog.innerHTML = '';
selectionLog.appendChild(labelElement);
selectionLog.appendChild(valueElement);
}
}
}
}
};
</script>
<style>
</style>

Run Code

Angular UI Components Documentation

Angular ComboBox Component

The ComboBox component for Angular contains an input field with auto-complete functionality and a list of selectable items displayed in a drop-down.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<jqxComboBox [theme]="'fluent'" 
    [width]='250' [height]='25' 
    [source]='source' [selectedIndex]='0'>
</jqxComboBox>	

3. Setup Component Logic

app.component.ts


import { Component, ViewChild } from '@angular/core';

import { jqxComboBoxModule, jqxComboBoxComponent } from 'jqwidgets-ng/jqxcombobox';
@Component({
    selector: 'app-root',
    imports: [jqxComboBoxModule],
    standalone: true,
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css'],
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    source: any[] = this.generateHTML();

    generateHTML(): any[] {
        let source = new Array();

        for (let i = 0; i < 10; i++) {
            let movie = 'avatar.png';
            let title = 'Avatar';
            let year = 2009;
            switch (i) {
                case 1:
                    movie = 'endgame.png';
                    title = 'End Game';
                    year = 2006;
                    break;
                case 2:
                    movie = 'priest.png';
                    title = 'Priest';
                    year = 2011;
                    break;
                case 3:
                    movie = 'unknown.png';
                    title = 'Unknown';
                    year = 2011;
                    break;
                case 4:
                    movie = 'unstoppable.png';
                    title = 'Unstoppable';
                    year = 2010;
                    break;
                case 5:
                    movie = 'twilight.png';
                    title = 'Twilight';
                    year = 2008;
                    break;
                case 6:
                    movie = 'kungfupanda.png';
                    title = 'Kung Fu Panda';
                    year = 2008;
                    break;
                case 7:
                    movie = 'knockout.png';
                    title = 'Knockout';
                    year = 2011
                    break;
                case 8:
                    movie = 'theplane.png';
                    title = 'The Plane';
                    year = 2010;
                    break;
                case 9:
                    movie = 'bigdaddy.png';
                    title = 'Big Daddy';
                    year = 1999;
                    break;
            }
            let html = "<div style='padding: 0px; margin: 0px; height: 95px; float: left;'><img width='60'" +
                "style='float: left; margin-top: 4px; margin-right: 15px;' src='https://www.jqwidgets.com/angular/images/" + movie
                + "'/><div style='margin-top: 10px; font-size: 13px;'>" + "<b>Title</b><div>" + title +
                "</div><div style='margin-top: 10px;'><b>Year</b><div>" + year.toString() + "</div></div></div>";
            source[i] = { html: html, title: title };
        }
        return source;
    }
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

ComboBox API

API Reference of the jQWidgets ComboBox component for Angular: ComboBox API

React UI Components Documentation

Typescript React ComboBox Component

This tutorial will show you the basics of how to get started with the jQWidgets ComboBox React Component.

Prerequisites

Refer to Getting Started with React before you start with this help topic.

Structure


I. Imports:

import * as React from 'react';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.base.css';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.material-purple.css';
import JqxComboBox, { IComboBoxProps } from 'jqwidgets-scripts/jqwidgets-react-tsx/jqxcombobox';

II. Class:

class App extends React.PureComponent<{}, IComboBoxProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxComboBox
width={this.state.width} height={"100%"} .....
/>
)
}
}

III. Render:

ReactDOM.render(<App />, document.getElementById('app'));

Events

The event names in React are constructed of the original event names starting with capital letter plus on upfront:

class App extends React.PureComponent<{}, IComboBoxProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxComboBox onNameOfEvent={this.handleEvent}
width={this.state.width} height={"100%"} .....
/>
)
}
private handleEvent(e: Event): void {
// Do Something ...
}
}

Methods & Properties

This is how you call methods & props:

//Get Methods
const value = this.myComboBox.current!.methodName(arg1, arg2);
//Set Methods
this.myComboBox.current!.methodName(arg1, arg2);
//Get Properties
const height = this.state.height;
//Set Properties
this.setState({ height: 250 });

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

Every component also have a method getOptions which returns the value of the requested option.

const width = this.myComboBox.current!.getOptions('width');

ComboBox API

API Reference of the jQWidgets ComboBox React Component: ComboBox API

ComboBox Demos

Demos Reference of the jQwidgets ComboBox React Component: ComboBox Demos